#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "webutil.h"
#include "food.h"

/*----------------------------------------------------------------------------*/

static char* types[] = {
   "African",
   "Bar/Club/Pub",
   "Cafe/Bistro",
   "Canadian/American",
   "Caribbean",
   "Chinese",
   "Deli/Diner",
   "East-European",
   "French",
   "Greek",
   "Indian",
   "Italian",
   "Japanese",
   "Latin/Spanish/Portugese",
   "Middle-Eastern",
   "Seafood",
   "South-Asian",
   "Steak House",
   "Tex/Mex",
   "Vegetarian",
   "Wine Bar",
   "Other",
   0
};

static char *locations[] = {
   "Annex",
   "Cabbagetown",
   "Central",
   "Chinatown/Kensington",
   "Esplanade",
   "Financial District",
   "Harbourfront",
   "Queen St. W.",
   "Theatre District",
   "Yorkville",
   "Mount Pleasant",
   "Rosedale",
   "Yonge & Eglinton",
   "Yonge & St. Clair",
   "Beaches",
   "Danforth",
   "East End",
   "Gerrard East",
   "Scarborough",
   "St. Clair West",
   "Eglinton West",
   "Etobicoke",
   "High Park",
   "Little Italy",
   "Mississauga",
   "Markham",
   "North York",
   "Richmond Hill",
   "Thornhill",
   "Woodbridge/Brampton",
   0
};

/*----------------------------------------------------------------------------*/

static long int all_types;

/*----------------------------------------------------------------------------*/

static char* URLorName( char *name, char *path )
{
/*
 * EGN:  no clients for now.
 *
   static char buf[128];

   if( strcmp( path, " " ) == 0 ) return( name );
   else
   {
      sprintf( buf, "<A HREF=\"/food/pages/%s/\">%s</A>",
      path, name );
      return( buf );
   }
*/
   return( name );
}

/*----------------------------------------------------------------------------*/

static char* LandMark( char *s )
{
   static char buf[128];
   if( strcmp( s, " " ) == 0 ) return( "" );
   else
   {
      sprintf( buf, "<I>%s</I>, ", s );
      return( buf );
   }
}

/*----------------------------------------------------------------------------*/

static void DumpList( fp, title, address, type_mask, type_and, price_mask,
location_mask )
FILE *fp;
char *title, *address;
long int type_mask;
int type_and;
int price_mask;
long int location_mask;
{
   extern char *re_comp( char* );
   extern int re_exec( char* );

   char buffer[512], tmp[128];
   char name[128], path[256], addr[128], landmark[128], city[128], phone[128];

   int location, price;
   long int type;
   int n = 0, chk_title = 0, chk_addr = 0;

   if( title != 0 && strcmp( title, "" ) != 0 )
   {
      if( re_comp( title ) )
         printf( "<B>You have entered an invalid expression: %s</B>%c",
         title, 10 );
      else 
         chk_title = 1;
   }

   if( address != 0 && strcmp( address, "" ) != 0 )
   {
      if( re_comp( address ) )
         printf( "<B>You have entered an invalid expression: %s</B>%c",
         address, 10 );
      else 
         chk_addr = 1;
   }

   while( fgets( buffer, 512, fp ) != 0 )
   {
      int title_match, addr_match, type_match, price_match, location_match;

      sscanf( buffer, DB_FMT, name, path, addr, landmark, &location, city,
              phone, &type, &price );

      if( chk_title )
      {
         re_comp( title );
         sprintf( tmp, "%s", name );
         lowercase( tmp );
         title_match = re_exec( tmp );
      }
      else
         title_match = 1;

      if( chk_addr )
      {
         re_comp( address );
         sprintf( tmp, "%s", addr );
         lowercase( tmp );
         addr_match = re_exec( tmp );
      }
      else
         addr_match = 1;

      if( type_and )
      {
         if( type_mask != all_types )
            type_match = (type == type_mask);
         else
            type_match = 1;
      }
      else
         type_match = (type & type_mask) != 0;

      price_match = (pow2( price ) & price_mask) != 0;

      location_match = (pow2( location ) & location_mask) != 0;

      if( title_match && addr_match && type_match && price_match &&
          location_match )
      {
         printf( HTML_FMT,
                 URLorName( name, path ), addr, LandMark( landmark ),
                 city, phone, 10 );
         n++;
      }
   }
   printf( "<P><HR><I>Query generated <B>%d</B> hits.</I>%c", n, 10 );
   printf( SIG );
   printf( "</body>%c", 10 );
}

/*----------------------------------------------------------------------------*/

int main( int argc, char *argv[] )
{
   entry entries[MAX_ENTRIES];
   register int x, m = 0;
   int cl;
   long int type_mask = 0;
   int type_and = 0;
   char *title_pattern = 0;
   char *addr_pattern = 0;
   int price_mask = 0;
   long int location_mask = 0;
   int empty_query = 1;

   printf( "Content-type: text/html%c%c", 10, 10 );

   if( strcmp( getenv( "REQUEST_METHOD" ), "POST" ) )
   {
      printf( "This script should be referenced with a METHOD of POST.\n" );
      printf( "If you don't understand this, see this ");
      printf( "<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c", 10 );
      exit( 1 );
   }
   if( strcmp( getenv("CONTENT_TYPE"), "application/x-www-form-urlencoded") )
   {
      printf( "This script can only be used to decode form results.\n" );
      exit( 1 );
   }
   cl = atoi( getenv( "CONTENT_LENGTH" ) );

   {
      char path[256];
      FILE* fp;

      sprintf( path, "%s/%s/logs/search.log", ROOT, CLIENT );
      fp = fopen( path, "a" );

      for( x = 0; cl && ( !feof( stdin ) ); x++ )
      {
         m = x;
         entries[x].val = fmakeword( stdin, '&', &cl );
         plustospace( entries[x].val);
         unescape_url( entries[x].val );
         entries[x].name = makeword( entries[x].val, '=' );
         fprintf( fp, "%s:'%s' ", entries[x].name, entries[x].val );
      }
      fprintf( fp, "\n" );
      fclose( fp );
   }

   printf(
   "<TITLE>Toronto's WWW Restaurant Listings - Query Results</TITLE>%c", 10 );
   printf( "<body background=\"/food/images/bg.jpg\">%c", 10 );
   printf( "<H2>Query Results</H2>%c<HR>", 10 );

   for( x = 0; x <= m; x++ )
   {
      int t;
      if( strcmp( entries[x].name, "type" ) == 0 )
      {
         if( atoi( entries[x].val ) != 0 )
            type_mask += pow2( atoi( entries[x].val ) );
         else
         {
            if( (t = stringIndex( entries[x].val, types )) != 0 )
               type_mask += pow2( t+1 );
         }
         empty_query = 0;
      }
      else if( strcmp( entries[x].name, "typeAnd" ) == 0 )
         type_and = atoi( entries[x].val );
      else if( strcmp( entries[x].name, "title" ) == 0 )
      {
         title_pattern = entries[x].val;
         lowercase( title_pattern );
         if( strcmp( title_pattern, "" ) != 0 )
            empty_query = 0;
      }
      else if( strcmp( entries[x].name, "address" ) == 0 )
      {
         addr_pattern = entries[x].val;
         lowercase( addr_pattern );
         if( strcmp( addr_pattern, "" ) != 0 )
            empty_query = 0;
      }
      else if( strcmp( entries[x].name, "price" ) == 0 )
      {
         price_mask += pow2( atoi( entries[x].val ) );
         empty_query = 0;
      }
      else if( strcmp( entries[x].name, "location" ) == 0 )
      {
         if( atoi( entries[x].val ) != 0 )
            location_mask += pow2( atoi( entries[x].val ) );
         else
         {
            if( (t = stringIndex( entries[x].val, locations )) != 0 )
               location_mask += pow2( t+1 );
         }
         empty_query = 0;
      }
      else if( strcmp( entries[x].name, "region" ) == 0 )
      {
         if( atol( entries[x].val ) != 0 )
            location_mask += atol( entries[x].val );
         empty_query = 0;
      }
   }
   if( ! empty_query )
   {
      char path[256];
      FILE* fp;

      sprintf( path, "%s/%s/lib/food.db", ROOT, CLIENT );
      fp = fopen( path, "r" );
      all_types = pow2( 23 ) - 1;
      if( type_mask == 0 ) type_mask = all_types;
      if( price_mask == 0 ) price_mask = pow2( 6 ) - 1;
      if( location_mask == 0 ) location_mask = pow2( 31 ) - 1;

      DumpList( fp, title_pattern, addr_pattern, type_mask, type_and,
                price_mask, location_mask );
      fclose( fp );
   }
   else
   {
      printf(
      "You did not select any search criteria.  Please try again.<BR>%c", 10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
   return 0;
}

/*----------------------------------------------------------------------------*/
