#include "defs.h"
Header(- Search Hints)

<h2>Hints for Using the Search Facility</h2>

<p>
 Unlike most other similar lists on the Web, our search engine lets you
 specify a large variety of combination queries.
 The following examples describe several common searching scenarios.

<p>
<ol>
 <li><i>I can remember a part of the restaurant name</i><br>
     You can enter any regular expression in the name and street fields.
     For example,
     <p><b>Name:</b> <tt>mez</tt><br>
     <p>will return all restaurants
     that have the letters "mez" anywhere in their name, while
     <p><b>Name:</b> <tt>^mez</tt>
     <p>will return restaurants whose name starts with the
     letters "mez".  This approach is also useful if you cannot remember
     the exact spelling of a restaurant or street name.
     expressions are not case-sensitive, so "mez" and "MEZ" are equivalent.

 <p>
 <li><i>I want to know the restaurants located on a particular street</i><br>
     Try:
     <p><b>Street:</b> <tt>baldwin</tt>
     <p>to obtain a list of restaurants located on Baldwin Street.

 <p>
 <li><i>I want to know the restaurants located in a particular
     neighbourhood</i><br>
     For example, selecting
     <p><b>Location:</b> <i>Beaches</i>
     <p>will return a list of
     restaurants located in the Beaches area, while selecting
     <p><b>Location:</b> <i>East</i>
     <p>will return all restaurants in the East region of Toronto
     (including Beaches).  Selecting
     <p><b>Location:</b> <i>Beaches</i>, <i>Danforth</i>
     <p>will return restaurants from both neighbourhoods.

 <p>
 <li><i>Like (2), but restrict to a section of some street</i><br>
     Some Toronto streets, like Yonge street for example, are very long
     and have many restaurants.  Thus, for example, entering
     <p><b>Street:</b> <tt>yonge</tt><br>
     <b>Location:</b> <i>Rosedale</i>
     <p>will return only the restaurants
     located on the section of Yonge street in Rosedale.
     Of course you could select several neighbourhoods such as
     <i>Rosedale</i> and <i>Central</i> to cover a larger section of
     Yonge street.

 <p>
 <li><i>I want to find all the <b>X</b>-type of restaurants</i><br>
     You can select arbitrary combinations of over 20 cuisine or
     restaurant types.  Selecting <i>AND options</i> will return a
     list of restaurants that match <b>all</b> of the chosen cuisine criteria,
     while selecting the <i>OR options</i> will return all restaurants
     that match at least one of the chosen criteria.  For example,
     <p><b>Type:</b> <i>Steak House</i>
     <p>will return a list of steak houses,
     selecting
     <p><i>AND options</i><br>
     <b>Type:</b> <i>Steak House</i><br>
     <b>Type:</b> <i>Seafood</i>
     <p>will return a list of restaurants that specialize in both steak
     and seafood, while
     <p><i>OR options</i><br>
     <b>Type:</b> <i>Steak House</i><br>
     <b>Type:</b> <i>Seafood</i>
     <p>will return a list of restaurants that specialize in steak or
     seafood (or both).

 <p>
 <li><i>Same as above, but restricted to certain locations
     and price range(s)</i><br>
     Selecting appropriate values in the location and
     price fields will further restrict the search and return a smaller
     (more focussed) number of hits.  For example,
     <p><b>Street:</b> <tt>eglinton</tt><br>
     <b>Type:</b> <i>Italian</i><br>
     <b>Dinner for two prices:</b> <i>$30-$60</i><br>
     <b>Location:</b> <i>Yonge & Eglinton</i>
     <p>will return a list of Italian restaurants in the Yonge and
     Eglinton area of Eglinton avenue
     that offer dinners for two in the range $30 to $60.
</ol>

<p>
ToolBar
Footer
